#ifndef H_GEOMETRY_TWO_D_SIGNUM
#define H_GEOMETRY_TWO_D_SIGNUM

/**
 * @file Contains helper function
 */

namespace geometry {
namespace two_d {

template<typename T>
  int signum(T n) {
    if (n < 0) return -1;
    if (n > 0) return 1;
    return 0;
  };

} // namespace two_d
} // namespace geometry
#endif
