#include "gtest/gtest.h"
#include "multmod_extended.h"
#include "debug/ppdebug.h"

namespace math {
namespace powermod {

  TEST(MultmodExtended, smallType) {
    int a = MultmodExtended<1>::multmod<short>(2, 2, 7);
    EXPECT_EQ(4, a);
    a = MultmodExtended<1>::multmod<unsigned short>(12345, 23456, 31111);
    EXPECT_EQ(14243, a);
    
    a = MultmodExtendedOpt::multmod<unsigned short>(12345, 23456, 31111);
    EXPECT_EQ(14243, a);
  }
} // namespace powermod
} // namespace math
