#include "gtest/gtest.h"
#include "powermod.h"
#include "multmod_extended.h"
#include "utils/benchmark/benchmark.h"
namespace math {
namespace powermod {

TEST(MultMod, benchmark) {
  int __tmp = 0;
  // Note: you need the additional parentheses around
  // expressions in benchmark because otherwise preprocessor
  // thinks of comma in templates as normal comma
  AUTO_BENCHMARK(__tmp+=MultmodExtended<1>::multmod(276552, 15474, 3289061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<2>::multmod(276552, 15474, 3289061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<3>::multmod(276552, 15474, 3289061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<4>::multmod(276552, 15474, 3289061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<8>::multmod(276552, 15474, 3289061));
  AUTO_BENCHMARK(__tmp+=MultmodExtendedOpt::multmod(276552, 15474, 3289061));
  printf("\n");
  AUTO_BENCHMARK(__tmp+=MultmodExtended<1>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<2>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<4>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<6>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<8>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<10>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtended<12>::multmod(262143, 262143, 489061));
  AUTO_BENCHMARK(__tmp+=MultmodExtendedOpt::multmod(262143, 262143, 489061));
  printf("\n");
  AUTO_BENCHMARK(__tmp+=MultmodExtended<1>::multmod(111726919, 582098, 123456789));
  AUTO_BENCHMARK(__tmp+=MultmodExtendedOpt::multmod(111726919, 582098, 123456789));
  printf("magic %d\n", __tmp);
}

} // namespace powermod
} // namespace math
