#ifndef H_SEARCH_CALLBACK
#define H_SEARCH_CALLBACK

namespace strings {
namespace search_callback {

/**
 * Callback that reports match in string search problem
 */
template<typename _Iterator>
class SearchCallback {
  public:
    virtual void foundMatch(const _Iterator& start) = 0;
};

} // namespace search_callback
} // namespace strings

#endif
