#ifndef H_BRANCH_PREDICT
#define H_BRANCH_PREDICT

#ifdef __GNUC__
  #define LIKELY(x)       __builtin_expect((x),1)
  #define UNLIKELY(x)     __builtin_expect((x),0)
#else
  #define LIKELY(x) (x)
  #define UNLIKELY(x) (x)
#endif // __GNUC__

#endif
