#ifndef H_RAND
#define H_RAND
#include "utils/preconditions/preconditions.h"
#include <stdint.h>

class Rand
{
 public:
   Rand(unsigned int seed);
  /** Vygeneruj nahodne cislo s exponencialnym rozlozenim
    (rovnomerne rozlozenie v log-hodnotach)
    z intervalu <min, max)
    */
  unsigned int rand();
  int rand(int min, int max);
  int exprand(unsigned int min, unsigned int max);
  double randdouble(double min, double max);
  double expranddouble(double min, double max);
 private:
  uint64_t my_seed;
};

//TODO(fix this)
#include "rand.cpp"
#endif
