#ifndef H_GEOMETRY_TWO_D_LINESEGMENT
#define H_GEOMETRY_TWO_D_LINESEGMENT

#include "point.h"
namespace geometry {
namespace two_d {

template<typename T>
struct LineSegment {
  Point<T> begin;
  Point<T> end;
  LineSegment() {
  }
  LineSegment(Point<T> b, Point<T> e) {
    begin = b;
    end = e;
  }
};

} // namespace two_d
} // namespace geometry
#endif
